# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities
from . import outputs

__all__ = [
    'GetWorkersSecretsResult',
    'AwaitableGetWorkersSecretsResult',
    'get_workers_secrets',
    'get_workers_secrets_output',
]

@pulumi.output_type
class GetWorkersSecretsResult:
    """
    A collection of values returned by getWorkersSecrets.
    """
    def __init__(__self__, account_id=None, dispatch_namespace=None, id=None, max_items=None, results=None, script_name=None):
        if account_id and not isinstance(account_id, str):
            raise TypeError("Expected argument 'account_id' to be a str")
        pulumi.set(__self__, "account_id", account_id)
        if dispatch_namespace and not isinstance(dispatch_namespace, str):
            raise TypeError("Expected argument 'dispatch_namespace' to be a str")
        pulumi.set(__self__, "dispatch_namespace", dispatch_namespace)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if max_items and not isinstance(max_items, int):
            raise TypeError("Expected argument 'max_items' to be a int")
        pulumi.set(__self__, "max_items", max_items)
        if results and not isinstance(results, list):
            raise TypeError("Expected argument 'results' to be a list")
        pulumi.set(__self__, "results", results)
        if script_name and not isinstance(script_name, str):
            raise TypeError("Expected argument 'script_name' to be a str")
        pulumi.set(__self__, "script_name", script_name)

    @property
    @pulumi.getter(name="accountId")
    def account_id(self) -> builtins.str:
        """
        Identifier
        """
        return pulumi.get(self, "account_id")

    @property
    @pulumi.getter(name="dispatchNamespace")
    def dispatch_namespace(self) -> builtins.str:
        """
        Name of the Workers for Platforms dispatch namespace.
        """
        return pulumi.get(self, "dispatch_namespace")

    @property
    @pulumi.getter
    def id(self) -> builtins.str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="maxItems")
    def max_items(self) -> Optional[builtins.int]:
        """
        Max items to fetch, default: 1000
        """
        return pulumi.get(self, "max_items")

    @property
    @pulumi.getter
    def results(self) -> Sequence['outputs.GetWorkersSecretsResultResult']:
        """
        The items returned by the data source
        """
        return pulumi.get(self, "results")

    @property
    @pulumi.getter(name="scriptName")
    def script_name(self) -> builtins.str:
        """
        Name of the script, used in URLs and route configuration.
        """
        return pulumi.get(self, "script_name")


class AwaitableGetWorkersSecretsResult(GetWorkersSecretsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetWorkersSecretsResult(
            account_id=self.account_id,
            dispatch_namespace=self.dispatch_namespace,
            id=self.id,
            max_items=self.max_items,
            results=self.results,
            script_name=self.script_name)


def get_workers_secrets(account_id: Optional[builtins.str] = None,
                        dispatch_namespace: Optional[builtins.str] = None,
                        max_items: Optional[builtins.int] = None,
                        script_name: Optional[builtins.str] = None,
                        opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetWorkersSecretsResult:
    """
    ## Example Usage

    ```python
    import pulumi
    import pulumi_cloudflare as cloudflare

    example_workers_secrets = cloudflare.get_workers_secrets(account_id="023e105f4ecef8ad9ca31a8372d0c353",
        dispatch_namespace="my-dispatch-namespace",
        script_name="this-is_my_script-01")
    ```


    :param builtins.str account_id: Identifier
    :param builtins.str dispatch_namespace: Name of the Workers for Platforms dispatch namespace.
    :param builtins.int max_items: Max items to fetch, default: 1000
    :param builtins.str script_name: Name of the script, used in URLs and route configuration.
    """
    __args__ = dict()
    __args__['accountId'] = account_id
    __args__['dispatchNamespace'] = dispatch_namespace
    __args__['maxItems'] = max_items
    __args__['scriptName'] = script_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('cloudflare:index/getWorkersSecrets:getWorkersSecrets', __args__, opts=opts, typ=GetWorkersSecretsResult).value

    return AwaitableGetWorkersSecretsResult(
        account_id=pulumi.get(__ret__, 'account_id'),
        dispatch_namespace=pulumi.get(__ret__, 'dispatch_namespace'),
        id=pulumi.get(__ret__, 'id'),
        max_items=pulumi.get(__ret__, 'max_items'),
        results=pulumi.get(__ret__, 'results'),
        script_name=pulumi.get(__ret__, 'script_name'))
def get_workers_secrets_output(account_id: Optional[pulumi.Input[builtins.str]] = None,
                               dispatch_namespace: Optional[pulumi.Input[builtins.str]] = None,
                               max_items: Optional[pulumi.Input[Optional[builtins.int]]] = None,
                               script_name: Optional[pulumi.Input[builtins.str]] = None,
                               opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetWorkersSecretsResult]:
    """
    ## Example Usage

    ```python
    import pulumi
    import pulumi_cloudflare as cloudflare

    example_workers_secrets = cloudflare.get_workers_secrets(account_id="023e105f4ecef8ad9ca31a8372d0c353",
        dispatch_namespace="my-dispatch-namespace",
        script_name="this-is_my_script-01")
    ```


    :param builtins.str account_id: Identifier
    :param builtins.str dispatch_namespace: Name of the Workers for Platforms dispatch namespace.
    :param builtins.int max_items: Max items to fetch, default: 1000
    :param builtins.str script_name: Name of the script, used in URLs and route configuration.
    """
    __args__ = dict()
    __args__['accountId'] = account_id
    __args__['dispatchNamespace'] = dispatch_namespace
    __args__['maxItems'] = max_items
    __args__['scriptName'] = script_name
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('cloudflare:index/getWorkersSecrets:getWorkersSecrets', __args__, opts=opts, typ=GetWorkersSecretsResult)
    return __ret__.apply(lambda __response__: GetWorkersSecretsResult(
        account_id=pulumi.get(__response__, 'account_id'),
        dispatch_namespace=pulumi.get(__response__, 'dispatch_namespace'),
        id=pulumi.get(__response__, 'id'),
        max_items=pulumi.get(__response__, 'max_items'),
        results=pulumi.get(__response__, 'results'),
        script_name=pulumi.get(__response__, 'script_name')))
