# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities
from . import outputs

__all__ = [
    'GetZeroTrustListsResult',
    'AwaitableGetZeroTrustListsResult',
    'get_zero_trust_lists',
    'get_zero_trust_lists_output',
]

@pulumi.output_type
class GetZeroTrustListsResult:
    """
    A collection of values returned by getZeroTrustLists.
    """
    def __init__(__self__, account_id=None, id=None, max_items=None, results=None, type=None):
        if account_id and not isinstance(account_id, str):
            raise TypeError("Expected argument 'account_id' to be a str")
        pulumi.set(__self__, "account_id", account_id)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if max_items and not isinstance(max_items, int):
            raise TypeError("Expected argument 'max_items' to be a int")
        pulumi.set(__self__, "max_items", max_items)
        if results and not isinstance(results, list):
            raise TypeError("Expected argument 'results' to be a list")
        pulumi.set(__self__, "results", results)
        if type and not isinstance(type, str):
            raise TypeError("Expected argument 'type' to be a str")
        pulumi.set(__self__, "type", type)

    @property
    @pulumi.getter(name="accountId")
    def account_id(self) -> builtins.str:
        return pulumi.get(self, "account_id")

    @property
    @pulumi.getter
    def id(self) -> builtins.str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="maxItems")
    def max_items(self) -> Optional[builtins.int]:
        """
        Max items to fetch, default: 1000
        """
        return pulumi.get(self, "max_items")

    @property
    @pulumi.getter
    def results(self) -> Sequence['outputs.GetZeroTrustListsResultResult']:
        """
        The items returned by the data source
        """
        return pulumi.get(self, "results")

    @property
    @pulumi.getter
    def type(self) -> Optional[builtins.str]:
        """
        The type of list.
        Available values: "SERIAL", "URL", "DOMAIN", "EMAIL", "IP".
        """
        return pulumi.get(self, "type")


class AwaitableGetZeroTrustListsResult(GetZeroTrustListsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetZeroTrustListsResult(
            account_id=self.account_id,
            id=self.id,
            max_items=self.max_items,
            results=self.results,
            type=self.type)


def get_zero_trust_lists(account_id: Optional[builtins.str] = None,
                         max_items: Optional[builtins.int] = None,
                         type: Optional[builtins.str] = None,
                         opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetZeroTrustListsResult:
    """
    ## Example Usage

    ```python
    import pulumi
    import pulumi_cloudflare as cloudflare

    example_zero_trust_lists = cloudflare.get_zero_trust_lists(account_id="699d98642c564d2e855e9661899b7252",
        type="SERIAL")
    ```


    :param builtins.int max_items: Max items to fetch, default: 1000
    :param builtins.str type: The type of list.
           Available values: "SERIAL", "URL", "DOMAIN", "EMAIL", "IP".
    """
    __args__ = dict()
    __args__['accountId'] = account_id
    __args__['maxItems'] = max_items
    __args__['type'] = type
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('cloudflare:index/getZeroTrustLists:getZeroTrustLists', __args__, opts=opts, typ=GetZeroTrustListsResult).value

    return AwaitableGetZeroTrustListsResult(
        account_id=pulumi.get(__ret__, 'account_id'),
        id=pulumi.get(__ret__, 'id'),
        max_items=pulumi.get(__ret__, 'max_items'),
        results=pulumi.get(__ret__, 'results'),
        type=pulumi.get(__ret__, 'type'))
def get_zero_trust_lists_output(account_id: Optional[pulumi.Input[builtins.str]] = None,
                                max_items: Optional[pulumi.Input[Optional[builtins.int]]] = None,
                                type: Optional[pulumi.Input[Optional[builtins.str]]] = None,
                                opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetZeroTrustListsResult]:
    """
    ## Example Usage

    ```python
    import pulumi
    import pulumi_cloudflare as cloudflare

    example_zero_trust_lists = cloudflare.get_zero_trust_lists(account_id="699d98642c564d2e855e9661899b7252",
        type="SERIAL")
    ```


    :param builtins.int max_items: Max items to fetch, default: 1000
    :param builtins.str type: The type of list.
           Available values: "SERIAL", "URL", "DOMAIN", "EMAIL", "IP".
    """
    __args__ = dict()
    __args__['accountId'] = account_id
    __args__['maxItems'] = max_items
    __args__['type'] = type
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('cloudflare:index/getZeroTrustLists:getZeroTrustLists', __args__, opts=opts, typ=GetZeroTrustListsResult)
    return __ret__.apply(lambda __response__: GetZeroTrustListsResult(
        account_id=pulumi.get(__response__, 'account_id'),
        id=pulumi.get(__response__, 'id'),
        max_items=pulumi.get(__response__, 'max_items'),
        results=pulumi.get(__response__, 'results'),
        type=pulumi.get(__response__, 'type')))
